module SpellCheckUnlifted where

import Types
import Trie
import Data.Array.Parallel.Unlifted
import GHC.PArr

type DocumentU = Array Word

spellCheck :: Dictionary -> Word -> Bool
spellCheck dic w = lookupTrie dic w

spellCheckU :: Dictionary -> Document -> [Word]
spellCheckU dic doc = 
  fromP ( filterP (\s -> not (spellCheck dic s)) (toP doc) )
